# Changelog

All notable changes to this project will be documented in this file.

## [0.98] - 2025-05-30
- Fix validity check in staffgraph filtering away any NRENs that had a zero value for a given year

## [0.97] - 2025-05-28
- Add fix for scrolling tables with more than one row in the header, the 2nd row in the header didn't follow

## [0.96] - 2025-04-07
- Fix bug with re-render throwing away state on survey object in survey management

## [0.95] - 2025-03-21
- COMP-461: Also match nren name when searching in user management

## [0.94] - 2025-03-19
- Fix Excel export for data that includes null values

## [0.93] - 2025-03-03
- Fix CSV/Excel export for data that includes object/array values

## [0.92] - 2025-02-13
- Put hashes on all filenames to bust nginx cache without forcing client cache update

## [0.91] - 2025-02-13
- Only allow valid survey responses to be published
- Add NREN exclusions which limits data from view / publishing for a given NREN & Year. If an NREN has an exclusion, they will not be able to answer the survey.

## [0.90] - 2025-02-12
- Fix incorrect link in sidebar/frontpage

## [0.89] - 2025-02-12
- COMP-453: Remove strategic plan link from policies page, as we have a separate page for that
- Use a single frontend entrypoint (index.html), as the code splitting now works properly with it
- COMP-449: Add manually fixed security controls data
- COMP-439: Fix HEAnet funding source data
- Update sidebar & compendium data ordering of page links
- Add survey validation to survey management page to easily validate surveys

## [0.88] - 2025-02-05
- Fix data download for models that are already stored in a flat format (previously only provided the last value for a given year, instead of all values)
- Fix ordering of years in ScrollableMatrix
- Add code-splitting to reduce load time significantly for everything except the survey (survey-core library is HUGE)
- Fix security controls import / publishing to not include comment if "other" wasn't selected
- Add year to ServiceMatrix tooltips

## [0.87] - 2025-02-05
- Use separate entrypoints for report & survey to reduce bundle sizes & load time

## [0.86] - 2025-02-05
- Fix old_db_2022 survey publisher to not use enum value when saving external connections

## [0.85] - 2025-01-28
- Add back in old data publishers until the exported survey data is manually validated

## [0.84] - 2025-01-28
- Fix budget data import from excel file to include 2016/2021
- Use the new React compiler for auto-memoized components (as long as they are pure)
- Require ESLint to pass for builds to ensure future code quality stays high

## [0.83] - 2025-01-24
- Allow observers to preview data
- Migrate to bun 1.2 and Vite to simplify bundling by getting rid of complex webpack configuration

## [0.82] - 2025-01-22
- Fix data download in case of survey responses that haven't been initialized for NRENs
- Add navigation to the survey pages for admins
- Add back validateWebsiteUrl validation function for the 2023 survey

## [0.81] - 2025-01-22
- Harden get_response_data for moving responses from a previous survey to a new survey year.
- Moved response data now satisfies the dependencies of the new survey. If a question would be hidden in the new survey, the data for that question is removed.
- Changed string lengths to minimum 256 and updated the survey publisher to handle max string lengths without erroring.

## [0.80] - 2025-01-21
- Add missing legacy_publisher module due to missing init file

## [0.79] - 2025-01-21
- COMP-281: Add delete user functionality to the user management page
- General improvements to the user management page
- Fix NREN sorting in ScrollableMatrix pages
- legacy survey publisher now outputs the same data as the excel/2022 db publishers when publishing generated surveys

## [0.78] - 2025-01-17
- COMP-371: Add S&P - EOSC Listings page (unlisted due to bad data)
- Only render http(s) links as links in URL tables
- Get rid of redundant collapsible-column css & fix up some css
- Add survey-publisher-legacy script for converting old response data into new surveys (reusing 2024 survey template)
- Fix minor bugs & minor improvements for frontend & backend
- Add legacy-survey-publisher script for generating surveys from 2016 to 2022 from the old data
- Fix mapping of survey response data for 2023/2024 publishers
- Add dry run functionality for publishing to the survey management page (it prints changes to the console)
- Convert all surveys except the 2023 survey to use the 2024 survey

## [0.77] - 2025-01-10
- COMP-369: Add Network - Capacity - External IP Connections page

## [0.76] - 2025-01-09
- Add missing links for the central procurement page

## [0.75] - 2025-01-09
- COMP-269: Address legibility issues in the survey & render survey descriptions as HTML with paragraphs from sentences
- COMP-312: Fix layout of compendium data page & width of boxes
- COMP-327: Add Kilometres of Leased Dark Fibre national & international pages
- COMP-364: Add Centralized Procurement page
- COMP-440: Add survey comments to the data download
- Update test data dump script to not share code with data download / API to simplify saving/loading the data dump
- Fix sidebar z-index to be above fixed table headers for small screens
- Add Connected Users Remote Campuses page


## [0.74] - 2024-12-19
- COMP-315: Allow any input for contacts, instead of requiring a URL (now actually fixed)
- COMP-407: Fix SIEM vendors page rendering of the other category
- COMP-431: Handle new internal_security_programme choice for crisis_exercises
- COMP-432: Merge service matrix data for open-lightpath-exchange and lambda
- COMP-433: Merge service matrix data for software-licenses into procurement for professional services
- COMP-434: Add External security awareness programme Security Service
- COMP-450: Add new text to connectivity load page
- Update survey validation to be less strict about missing URLs
- Establish proper code reuse throughout the application
- Fix various bugs and issues throughout the application
- Finalize required changes to be ready to publish 2024 survey data


## [0.73] - 2024-12-06
- Don't allow empty rows for traffic statistics and policy URLs given in the survey
- Fix URL validation to disallow spaces

## [0.72] - 2024-12-06
- Fix bug with nren now being an object

## [0.71] - 2024-12-06
- Add survey notes textbox to the survey management page that can be updated as required to keep notes about a survey response
- Update rendering to be more consistent, and all components now have access to the react-dom-router

## [0.70] - 2024-12-04
- Fix issues with rendering of pages/routes that reuse components with different props only

## [0.69] - 2024-12-04
- COMP-315: Allow any input for GDPR contacts, instead of requiring a URL
- COMP-339: Fix StaffGraph pages to only show NREN/year selection if there's data for the given page
- COMP-403: Make the current page bold in the sidebar
- COMP-418: Add Let's Encrypt to certificate provider table and remove unused providers
- COMP-431: Handle new internal_security_programme choice for crisis_exercises
- COMP-439: Update publishers to correct HEAnet funding source data
- COMP-441: Fix FibreLight Page
- COMP-442: Fix NFV Page
- COMP-443: Fix Network tasks for automation page
- COMP-447: Update publishers to correct CESNET traffic volume data for 2019
- COMP-455: Fix Traffic statistics page
- Update the survey validation to be triggered when a user starts editing a survey
- General refactoring and improvements throughout the application

## [0.68] - 2024-11-25
- COMP-351: Added graph for commodity vs R&E traffic
- COMP-435: Proper spellings of let's encrypt
- COMP-331: Add compendium to the navbar

## [0.67] - 2024-10-30
- Fix various things pointed out by Jenni during meeting

## [0.66] - 2024-10-26
bundle push

## [0.65] - 2024-10-26
- COMP-428: Change the color scheme for pills on report 
- COMP-365: S&P - Policy & Portfolio - service management
- COMP-366: S&P - Policy & Portfolio - Service level targets
- COMP-367: S&P - Policy & Portfolio - Services types for different users
- COMP-363: S&P - Policy & Portfolio - Corporate Strategy
- COMP-408: Add unit of measurement to Y-axis - and move within Network section
- COMP-358: Edit - Network - Alien-wave 3rd party graph

## [0.64] - 2024-10-25
- Make EOSC questions readonly
- Fix invalid html with nested paragraphs in survey navigation component
- General refactoring and improvements

## [0.63] - 2024-10-08
- Minor text change to the survey landing page
- Prevent publishing a survey year which doesn't have a mapped publishing function

## [0.62] - 2024-10-02
- Minor text changes to the survey
- Add Let's Encrypt to the certificate provider list in the survey (removing some unused providers)

## [0.61] - 2024-10-01
- COMP-424: Add new security services service to the service matrix
- COMP-421/422: Merge various survey options
- COMP-426: Edit crisis exercises options in the survey
- COMP-437: Update survey header text
- COMP-415: Changed Gender Equality Policy to Gender Equality Plan
- COMP-419: Added Let's Encrypt to Certificate Provider list
- COMP-397: Added "did not respond" rows to the survey admin table for NRENs that did not respond to the survey

## [0.60] - 2024-09-03
- Add consent form for Matomo tracking
- Add survey creator for surveys with custom fields

## [0.59] - 2024-07-10
- COMP-411: Add Matomo tracking for page visits to all Compendium Data pages and survey pages
- COMP-413: Merge survey and compendium data frontends into one

## [0.58] - 2024-04-18
- fix filename and titles for siem vendor and traffic volume page

## [0.57] - 2024-04-17
- COMP-370: Network - Capacity - total traffic from different sources
- COMP-405: Traffic Volumes page with 4 graphs
- COMP-406: Certification services used by NRENs - weird list

## [0.56] - 2024-04-05
- security control and crisis excersies fix for new 2023 mapping

## [0.55] - 2024-04-05
- COMP-372: S&P - Standards - Audits
- COMP-373: S&P - Standards - Business Continuity
- COMP-374: S&P - Standards - Crisis Management
- COMP-375: S&P - Standards - Crisis Exercises
- COMP-376: S&P - Standards - Security controls
- COMP-402: crisis management shows years with no data
- COMP-395: typo issue
- COMP-359: Tables - only show most recent data
- COMP-390: Remove line dots on the URL pages
- COMP-391: Fix place to click on side menu to pop out

## [0.54] - 2024-03-05
- Close the menu/sidebar when clicking outside of it
- Fix image download for pages with SVG icons inside the chart container

## [0.53] - 2024-03-04
- COMP-386/384: Text change

## [0.52] - 2024-03-04
- COMP-360: Network Automation
- COMP-322: correcting hover
- COMP-385: data download correction
- COMP-322: correcting hover
- COMP-381: link problem
- COMP-380/379/378: text change
- COMP-377: text change
- COMP-377: Connected Users - URLs
- COMP-356: Side menu - scroll option needed
- 

## [0.51] - 2024-02-28
- Add back in admin requirement for fast-tracked release
- Fix publisher functionality to make excel downloads work for 2023

## [0.50] - 2024-02-26
- COMP-330: Remove admin requirement to view the graph pages
- COMP-342/348/349/350: Added various network section graphs

## [0.49] - 2024-02-21
- COMP-340: Network section - PMM - Passive internat. traffic
- COMP-341: Network section - PMM - Traffic stats URL
- COMP-343: Network - PM&M - Certificate Service
- COMP-344: Network - PM&M - Weather Map
- COMP-345: Network - PM&M - PERT Team
- COMP-346: Network - PM&M - Alienwave external
- COMP-347: Network - PM&M - Alienwave internal
- COMP-352: Network - SDN&NFV - Automation of ops
- COMP-353: Network - SDN&NFV - Use of NFV
- COMP-354: Network - SDN&NFV - Automation Network
- COMP-335: Network - traffic stats
- COMP-334: Network section - map - URL
- COMP-336: Network - PM&M - tools
- COMP-333: Network section - equipment - fibre network


## [0.48] - 2024-02-08
- COMP-288: Minor fixes/changes to mass data download
- COMP-326: Always show all NRENs in the filter box, disabling unavailable nrens on specific pages
- COMP-313: Update text on various pages
- COMP-309: Add shadow around service matrix dots that have data.
- COMP-300: Fix the column widths for the service matrix and charging mechanism pages
- COMP-292: Fix column widths of connected users tables, and render the tables correctly
- COMP-250: Take user filters into account when downloading data
- COMP-202: Sort by nren name in staff graphs
- COMP-307: Add new graph with number of NREN employees (FTE)
- COMP-337: Remove zeros from budget data in publishers

## [0.47] - 2024-01-30
- COMP-288: Mass data download network and other models

## [0.46] - 2024-01-26
- COMP-288: Mass data download

## [0.45] - 2024-01-18
- COMP-329: Fix hook and bundle

## [0.44] - 2024-01-18
- COMP-329: User getting redirected with wrong year of survey

## [0.43] - 2023-12-07
- COMP-306: Renamed PIONEER to PSNC
- COMP-268: Renamed ANAS to AzScienceNet
- COMP-293: Updated download buttons design and placement
- COMP-292: Incorporated feedback for connected users section design

## [0.42] - 2023-11-27
- Added filtering to remove invalid budget and funding sources data
- Updated funding source graph to have static 0-100% x-axes
- Removed legend from the budget graph
- Added new buttons for downloading CSV/excel data as well as graph images

## [0.39] - 2023-10-19
- Removed filtering in publishers to show bad data
- Refactored parts of the data conversion module for building graph datasets

## [0.38] - 2023-10-05
- Updated redirection on the reporting landing page to not redirect admin users
- COMP-291: Fixed the NREN select box in the user management page

## [0.37] - 2023-09-26
- Refactored legacy publishers
- Add initial connected users and service sections
- Add presentation models for policy, connected users and network sections
- Make preview mode only available for admins

## [0.36] - 2023-09-14
- Fixed bug with sorting in user management page

## [0.35] - 2023-09-12
- Added a publisher for the 2023 survey data
- Added report pages for the traffic volume and institution urls
- Added sorting functionality for the survey users admin page
- Added a new 'observer' role in addition to 'admin' and 'user'
- Added a missing policy field in the reporting datamodel
- Changed the 'country' question in the survey from a dropdown to a text field

## [0.34] - 2023-08-27
- Fixed bug with "To" address for single email recipient

## [0.33] - 2023-08-27
- Fixed utf-8 issues with sending emails
- Fixed bug with applying migrations disabling all logging

## [0.32] - 2023-08-27
- Send an email to the user on first login
- Change NREN to (N)REN on the landing page

## [0.31] - 2023-08-24
- Fixed applying CSS class to all questions
- Increased width of the service name input fields in the services section
- Updated survey question descriptions

## [0.30] - 2023-08-22
- COMP-257: Added mail notification for new users on signup
- COMP-262: Changed text on the survey landing page
- Added download chart as CSV/PNG/SVG functionality to the reporting pages

## [0.29] - 2023-08-20
- More fixes to the survey model
- Fix small bugs in the progress bars
- Update the surveyjs version because it fixes a bug with the validation not jumping to the right question
- When editing the survey and clicking the back button now also gives a warning message if you stay on the survey website
- The conversion for prefill data now also includes data for the service matrix questions
- The next button is visible again to help with navigation
- The tooltips in the service matrix section are improved
- A completed survey can now not be saved anymore without validation

## [0.28] - 2023-08-16
- Added migration that updates all surveys to the fixed version
- Correctly handle read-only/edit mode (especially when user cannot edit)
- Updated survey description text

## [0.27] - 2023-08-15
- Added edit mode for surveys
- Fixed mistakes in survey titles and reordered service section
- Added initial CSV download button for compendium report pages
- Updated survey description text
- Changed user active default to true, so users only need to have an NREN added

## [0.26] - 2023-08-09
- Add toast messages when saving survey progress
- Changed application of styles to the survey through survey.css instead of manually applying classes
- Changed validation buttons to be added both on rerender and after a value has changed.
- Added back coloring of the question headers if there is a validation error

## [0.25] - 2023-08-07
- Update user management to work correctly, and update immediately on changes instead of an edit mode
- Removed duplicate modules in survey bundle
- Redirect to survey landing page when loading compendium-frontend in production mode

## [0.24] - 2023-08-03
- Add more information and links to the survey landing page
- Add error handling for surveys failing to load for various reasons in the frontend

## [0.23] - 2023-08-01
- Fix redirects when not logged in

## [0.22] - 2023-08-01
- COMP-232: Changed styling of the survey frontend
- Added simple admin user management page
- Added landing page for the survey
- Changed webpack setup to use webpack5 features for asset handling

## [0.21] - 2023-07-26
- Include missing frontend build artifact

## [0.20] - 2023-07-25
- Add WIP survey admin functionality
- Add simple login and navigation from reports page to the survey
- Fixed various bugs in the survey

## [0.19] - 2023-07-11
- Added survey functionality under new `/survey` route with a separate frontend from the compendium reports frontend
- Added authentication support for OIDC provider(s)
- Added survey question/data mapping & migration for 2022 survey

## [0.18] - 2023-05-31
- COMP-201 Funding Source UI
- adding axis scale 
- Font configuration fix
- funding source data 2021
- COMP-197 vertical header
- COMP-196 report link
- UI fix footer and collapse button
- COMP-195 title and description

## [0.17] - 2023-05-24
- COMP-184 Funding Source UI upgrade
- COMP-188 Nren Name correction
- COMP-186 Fixed Graph Size
- country to nren filterbo
- Fixing side bars and banner
- Collapsible box
- clean up

## [0.16] - 2023-05-17
- COMP-143 Policy Page UI changes 
- COMP-180 Year selection UI chnages

## [0.15] - 2023-05-16
- Added sentry SDK integration using SENTRY_DSN environment variable
- Added NREN policy data
- Changed layout of tables
- Fixed colors in charging mechanism table
- Refactor to use flask-sqlalchemy and flask-migrate

## [0.14] - 2023-05-03
- Added a navigation sidebar to Organization pages

## [0.13] - 2023-05-02
- Added the staff graph pages
- Updated the filter drop down boxes
- Added the organization table pages
- Added the EC projects table page
- Changed the charging mechanism page to use a table instead of a graph
- Code quality: updated the SQLalchemy models to 2.0 syntax

## [0.12] - 2023-04-18
- Added font-face definitions (obtained from Webpack output) to support open sans font with weight 600 in Firefox

## [0.11] - 2023-04-18
- Added filtering mechanism for NRENs and years
- Added footer
- Changed navigation header to match geant.org

## [0.10] - 2023-04-12
- Added first version of the charging mechanism page

## [0.9] - 2023-03-21
- Changed survey-publisher-2022 to function with newer sqlalchemy versions
- Changed fundingsource graph to be centered
- Added funding route to index.html
- Added /funding link under /compendiumdata

## [0.8] - 2023-03-21
- Updated frontend build artifact

## [0.7] - 2023-03-21
- Fix API call URL http -> https redirect bug
- Add survey-publisher-v1
- Add survey-publisher-2022
- Add funding sources API
- Add initial funding sources frontend work

## [0.6] - 2023-02-22
- API for budget data
- Initial processing of Budget data from survey DB into presentation DB
- Created new frontend that follows visual guide by Paul

## [0.5] - 2022-12-21
- Final layout (WIP)

## [0.4] - 2022-12-06


## [0.3] - 2022-12-06


## [0.2] - 2022-11-22
 - COMP-48: Added SQLAlchemy link to the survey database, including instructions to create the database locally
 - Added additional code validation tools

## [0.1] - 2022-11-07
- Initial skeleton - First Release
- COMP-2: Prototype Data only Service Matrix
- COMP-31: Baseline React routing structure
