import React from 'react';
import ChartContainer from "compendium/components/graphing/ChartContainer";

interface InputProps {
    children: React.ReactNode;
    location?: "top" | "bottom" | "both"
}

const WithLegend: React.FC<InputProps> = ({ children, location }) => {

    if (!location) location = "both";
    const top = location === "top" || location === "both";
    const bottom = location === "bottom" || location === "both";

    return (
        <ChartContainer>
            {top && <div style={{ paddingLeft: '33%', 'paddingTop': '2.5rem', 'paddingBottom': '1.5rem' }} id={'legendtop'} />}
            {children}
            {bottom && <div style={{ paddingLeft: '33%', 'paddingTop': '1.5rem' }} id={'legendbottom'} />}
        </ChartContainer>
    );
};

export default WithLegend;
