import { Link } from "react-router-dom";
import LinkWithHighlight from 'compendium/components/LinkWithHighlight';
import titles from "compendium/titles";

export default function NetworkLinks({ sidebar = false }) {
    const LinkComponent = sidebar ? LinkWithHighlight : Link;
    const classNames = sidebar ? "" : "link-text-underline";

    return (<>
        {sidebar && <h5>Network</h5>}
        <h6 className="section-title">Connectivity</h6>

        <LinkComponent to="/dark-fibre-lease" className={classNames}>
            <span>{titles["dark-fibre-lease"]}</span>
        </LinkComponent>
        <LinkComponent to="/dark-fibre-lease-international" className={classNames}>
            <span>{titles["dark-fibre-lease-international"]}</span>
        </LinkComponent>
        <LinkComponent to="/iru-duration" className={classNames}>
            <span>{titles["iru-duration"]}</span>
        </LinkComponent>
        <LinkComponent to="/dark-fibre-installed" className={classNames}>
            <span>{titles["dark-fibre-installed"]}</span>
        </LinkComponent>
        <LinkComponent to="/fibre-light" className={classNames}>
            <span>{titles["fibre-light"]}</span>
        </LinkComponent>
        <LinkComponent to="/network-map" className={classNames}>
            <span>{titles["network-map"]}</span>
        </LinkComponent>

        <hr className="fake-divider" />
        <h6 className="section-title">Performance Monitoring & Management</h6>
        <LinkComponent to="/monitoring-tools" className={classNames}>
            <span>{titles["monitoring-tools"]}</span>
        </LinkComponent>
        <LinkComponent to="/passive-monitoring" className={classNames}>
            <span>{titles["passive-monitoring"]}</span>
        </LinkComponent>
        <LinkComponent to="/traffic-stats" className={classNames}>
            <span>{titles["traffic-stats"]}</span>
        </LinkComponent>
        <LinkComponent to="/siem-vendors" className={classNames}>
            <span>{titles["siem-vendors"]}</span>
        </LinkComponent>
        <LinkComponent to="/certificate-providers" className={classNames}>
            <span>{titles["certificate-provider"]}</span>
        </LinkComponent>
        <LinkComponent to="/weather-map" className={classNames}>
            <span>{titles["weather-map"]}</span>
        </LinkComponent>
        <LinkComponent to="/pert-team" className={classNames}>
            <span>{titles["pert-team"]}</span>
        </LinkComponent>

        <hr className="fake-divider" />
        <h6 className="section-title">Alienwave</h6>
        <LinkComponent to="/alien-wave" className={classNames}>
            <span>{titles["alien-wave"]}</span>
        </LinkComponent>
        <LinkComponent to="/alien-wave-internal" className={classNames}>
            <span>{titles["alien-wave-internal"]}</span>
        </LinkComponent>

        <hr className="fake-divider" />
        <h6 className="section-title">Capacity</h6>
        <LinkComponent to="/capacity-largest-link" className={classNames}>
            <span>{titles["capacity-largest-link"]}</span>
        </LinkComponent>
        <LinkComponent to="/capacity-core-ip" className={classNames}>
            <span>{titles["capacity-core-ip"]}</span>
        </LinkComponent>
        <LinkComponent to="/external-connections" className={classNames}>
            <span>{titles["external-connections"]}</span>
        </LinkComponent>
        <LinkComponent to="/non-rne-peers" className={classNames}>
            <span>{titles["non-rne-peers"]}</span>
        </LinkComponent>
        <LinkComponent to="/traffic-volume" className={classNames}>
            <span>{titles["traffic-volume"]}</span>
        </LinkComponent>
        <LinkComponent to="/traffic-ratio" className={classNames}>
            <span>{titles["traffic-ratio"]}</span>
        </LinkComponent>

        <hr className="fake-divider" />
        <h6 className="section-title">Software-Defined Networking (SDN) & Network Function Virtualisation(NFV)</h6>
        <LinkComponent to="/ops-automation" className={classNames}>
            <span>{titles["ops-automation"]}</span>
        </LinkComponent>
        <LinkComponent to="/nfv" className={classNames}>
            <span>{titles["nfv"]}</span>
        </LinkComponent>
        <LinkComponent to="/network-automation" className={classNames}>
            <span>{titles["network-automation"]}</span>
        </LinkComponent>
    </>);
}
