import { useContext } from "react";
import { configContext, BaseConfig } from "compendium/providers/ConfigProvider";

export function useConfig<T extends BaseConfig>(key: string): Record<string, T> & {
    setConfig: (value: T, timeout?: Date) => void
} {
    const { getConfig, setConfig } = useContext(configContext);

    const configValue = getConfig(key);
    return {
        [key]: configValue,
        setConfig: (value: T, timeout?: Date) => setConfig(key, value, timeout)
    } as Record<string, T> & {
        setConfig: (value: T, timeout?: Date) => void
    };
}