import { IoIosCheckmarkCircle, IoIosCloseCircle } from "react-icons/io";
import { Button } from "react-bootstrap";

interface StatusButtonProps {
    status: string;
}

function StatusButton({ status }: StatusButtonProps) {
    const statusIcon = {
        "completed": <Button variant="success" size="sm"><strong>Completed</strong></Button>,
        // "completed": <IoIosCheckmarkCircle title={status} size={24} color="green" />,
        "started": <Button variant="warning" size="sm"><strong>Started</strong></Button>,
        // "started": <IoIosCheckmarkCircleOutline title={status} size={24} color="rgb(217, 117, 10)" />,
        "did not respond": <Button variant="danger" size="sm"><strong>Did not respond</strong></Button>,
        // "did not respond": <IoIosCloseCircle title={status} size={24} color="red" />,
        "not started": <Button variant="info" size="sm"><strong>Not started</strong></Button>,
        // "not started": <IoIosCloseCircleOutline title={status} size={24} />,
        "true": <IoIosCheckmarkCircle size={24} color="green" />,
        "false": <IoIosCloseCircle size={24} color="red" />,
    };
    return (
        statusIcon[status] || status
    );
}

export default StatusButton;
