import os
import json

from compendium_v2.helpers import get_survey_question_dependency_graph


def _test_data(filename):
    data_filename = os.path.join(os.path.dirname(__file__), 'data', filename)

    with open(data_filename, "r") as f:
        return json.load(f)


def test_dependency_graph():

    survey_model = _test_data('survey_model_2024_testdata.json')
    dependency_graph = get_survey_question_dependency_graph(survey_model)
    assert dependency_graph

    for key, val in dependency_graph.items():
        assert isinstance(key, str)
        assert isinstance(val, list)

        for item in val:
            assert isinstance(item, tuple)

            assert len(item) == 2

            tuple_key, tuple_val = item
            assert isinstance(tuple_key, str)

            if isinstance(tuple_val, tuple):
                assert tuple_key in ['or', 'and']
                assert len(tuple_val) > 1
            else:
                assert isinstance(tuple_val, str) or isinstance(tuple_val, list)
